/*
 * Color Picker
 * colorpick.java -- main class
 * (C) 1998 Filip Pizlo
 */

import java.awt.*;

public class colorpick extends Panel implements Runnable {
 public cpscroll red,green,blue;
 Label redl,greenl,bluel;
 Runnable cback;
 public colorpick(Runnable _cback,int rv,int gv,int bv) {
  super();
  cback=_cback;
  setLayout(new BorderLayout());
  red=new cpscroll(this,rv);
  green=new cpscroll(this,gv);
  blue=new cpscroll(this,bv);
  redl=new Label(bufint(rv));
  greenl=new Label(bufint(gv));
  bluel=new Label(bufint(bv));
  Panel p1=new Panel();
  Panel p2=new Panel();
  Panel p3=new Panel();
  p1.setLayout(new GridLayout(3,1));
  p2.setLayout(new GridLayout(3,1));
  p3.setLayout(new GridLayout(3,1));
  p1.add(new Label("Red:",Label.RIGHT));
  p1.add(new Label("Green:",Label.RIGHT));
  p1.add(new Label("Blue:",Label.RIGHT));
  p2.add(red);
  p2.add(green);
  p2.add(blue);
  p3.add(redl);
  p3.add(greenl);
  p3.add(bluel);
  add("West",p1);
  add("Center",p2);
  add("East",p3);
 }
 public void set(int r,int g,int b) {
  red.setValue(r);
  green.setValue(b);
  blue.setValue(g);
  redl.setText(bufint(r));
  greenl.setText(bufint(g));
  bluel.setText(bufint(b));
 }
 protected String bufint(int x) {
  String ret=""+x;
  for (int i=ret.length();i<3;i++) ret="0"+ret;
  return ret;
 }
 public Color getcolor() {
  return new Color(red.getValue(),green.getValue(),blue.getValue());
 }
 public void run() {
  cback.run();
  redl.setText(bufint(red.getValue()));
  greenl.setText(bufint(green.getValue()));
  bluel.setText(bufint(blue.getValue()));
 }
}

